## Ein Script für ReverseProxy und Wartungsmodus
Mit dem Script lassen sich alle Webseiten auf einem Server, am ISPConfig vorbei, in den Wartungsmodus oder auch den ReverseProxy für jede Webseite aktivieren.  
**Gedachter Einsatz:** Bspw. beim Upgrade eines OpenVZ Servers auf KVM um sich dann, gerade bei vielen Seiten, schnell alle Webseiten in Wartung zu setzen bzw. schnell Proxy für alle Seiten zu aktivieren.

### Usage
- **Warungsmodus**
  - `./rp-maint.sh --maint`
- **ReverseProxy**
  - `./rp-maint.sh --proxy ip.ip.ip.ip`
- **Routing** (aktuell nur in Kombination mit ISPCopy)
  - `./rp-maint.sh --routing`
- **Crons löschen**
  - `./rp-maint.sh --clearcrons`

### How does it work ?
Das Script zieht sich direkt aus der ISPConfig Datenbank eines Servers die vorhandenen Web-Domains und deren Details und
- schreibt die vHosts neu
- führt ein `nginx -t` aus
- startet den nginx einmal durch.  

Die ursprünglichen Konfigurationen schiebt das Scrip dabei nach `/etc/nginx/TIMESTAMP-sites-semi-available/` und via `/bin/mv /etc/nginx/TIMESTAMP-sites-semi-available/* /etc/nginx/sites-available/` kann man die Änderungen auch schnell wieder rückgängig machen wenn etwas failen sollte.  

### Routing
Das Mail Routing funktioniert im Moment nur in Kombination mit ISPCopy.  
Das Script zieht sich aus der Datei `/root/ispcopy/ispcopy_input.ini` das Ziel für das MailRouting.  
Das Routing wird dabei komplett unabhängig von ISPConfig erstellt und wird mittels [Nginx Stream Modul](http://nginx.org/en/docs/stream/ngx_stream_core_module.html) umgesetzt.
Im Ablauf wird dabei erst die Konfiguration geschrieben und getestet, dann werden postfix und dovecot gestoppt, damit keine Interaktion mehr stattfinden kann, dann wird noch ein letzter rsync angeschoben und dann wird der nginx durchgestartet und leitet die Anfragen an die jeweiligen [Mail Ports](https://git.timmehosting.de/devops/scripte-sammlung/rp-maint/-/blob/master/rp-maint.sh#L135) durch.

Um das Routing wieder zu deaktivieren // ursprünglichen Zustand zu restoren:
- die Datei `/etc/nginx/nginx_mail_stream.conf` löschen
- `service nginx restart`
- `service postfix start`
- `service dovecot start`

Das Routing setzt die alten IPs ebenfalls die alten IPs auf dem neuen Server als Whitelist inkl. einem Cronjob der die Datei dann nach 30 Tagen löscht.

### Crons aufräumen
Dafür schaut das Script ganz simpel ob es in `/etc/cron.d/` `ispcxxxxx` und ob es in `/var/spool/crons/crontabs/` `webx` Dateien gibt. Falls ja, dann wird ein `/root/cron_backup_(TIMESTAMP)` ordner erstellt und die Cron-Dateien werden einfach nach verschoben.

### IP Mapping
Damit IP Mapping funktioniert, muss die Datei `/root/ispcopy/ispcopy_input.ini` vorhanden sein (diese wird eh von der neueren Version von ISPCopy erstell.).  
In der Datei muss bspw. folgendes enthalten sein:
```
target_server_ip=NEUE.HAUPT.IP.ADRESSE
replace_ip_ddd_ddd_ddd_ddd=aaa.aaa.aaa.aaa
replace_ip_eee_eee_eee_eee=bbb.bbb.bbb.bbb
```
Dann kann das Script auch das IP Mapping
- **ReverseProxy IP Mapping**
  - `./rp-maint.sh --ispcopy_ini`

### Was zu beachten ?
Es könnte eventuell bei MirrorServern bzw. bei alten Clouds knartschen. Da müsste man vielleicht nochmal nachschauen. Wobei MirrorServer aber meist nur als NS2 vom Kunden genutzt werden sollten ohne dass sich darauf Webseiten befinden.  

### How to install:
- Wer mit SSH Agend unterwegs ist:
```bash
git clone git@git.timmehosting.de:devops/scripte-sammlung/rp-maint.git /root/rpmaint
/bin/bash /root/rpmaint/rp-maint.sh {args}
```
- Per HTTPs
```bash
git clone https://git.timmehosting.de/devops/scripte-sammlung/rp-maint.git /root/rpmaint
# BenutzerDaten eingeben
/bin/bash /root/rpmaint/rp-maint.sh {args}
```
